/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights 
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:  
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "WSIF" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written 
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation and was
 * originally based on software copyright (c) 2001, 2002, International
 * Business Machines, Inc., http://www.apache.org.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package org.apache.wsif.compiler.schema.tools;

import java.util.*;

/**
 * ClassFile
 * Creation date: (5/30/00 2:04:09 PM)
 * @author: Tian Zhao (tzhao@cs.purdue.edu)
 */
public class ClassFile {

    private Vector fields = new Vector();
    private Vector innerClasses = new Vector();
    String className; // This is a required field.
    String packageName; // By default, no package or super class name is required.
    String superClassName;
    boolean isAbstract = false;
    boolean isFinal = false;
    
    /**
     * Insert the method's description here.
     * Creation date: (5/30/00 2:52:00 PM)
     * @param cName java.lang.String
     * @param pName java.lang.String
     */
    public ClassFile(String className) {

        this.className = className;

    }
    
    /**
     * Insert the method's description here.
     * Creation date: (5/30/00 2:11:49 PM)
     * @param field schema2JavaVersion2.ClassField
     */
    public void addField(ClassField field) {

        fields.addElement(field);
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (5/30/00 2:17:15 PM)
     * @param innerClass schema2JavaVersion2.ClassFile
     */
    public void addInnerClass(ClassFile innerClass) {

        innerClasses.addElement(innerClass);
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (5/30/00 2:48:41 PM)
     * @return schema2JavaVersion2.ClassField
     * @param i int
     */
    public ClassField getField(int i) {

        return (ClassField) fields.elementAt(i);
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (5/30/00 2:18:37 PM)
     * @return int
     */
    public int getFieldCount() {
        return fields.size();
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (5/30/00 2:49:54 PM)
     * @return schema2JavaVersion2.ClassFile
     * @param i int
     */
    public ClassFile getInnerClass(int i) {
        return (ClassFile) innerClasses.elementAt(i);
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (5/30/00 2:19:05 PM)
     * @return int
     */
    public int getInnerClassCount() {
        return innerClasses.size();
    }
}